unit buildsql;

interface

uses
  {$ifdef win32}
  Windows,
  {$endif}
  SysUtils, Classes,
  ComCtrls, Controls, StdCtrls, ExtCtrls,
 {$ifdef WIN32}
  Forms,Messages,
  //dateutils,
  Graphics,
  Dialogs,
  contnrs,
 {$ENDIF}
  // gsqlparser_ao_TLB,comobj, activex,

  lzbasetype,
  // LzSourceToken,
  gsqlparser,
  selectstatement,
  altertablestatement,
  updatestatement,
  deletestatement,
  sqlstatement,insertstatement,
  createtablestatement,
  ddlstatement,
  lzexpression,
  {$ifdef DotNet}
   System.ComponentModel,
  {$endif}
  {$ifdef USE_TNTCONTROL}
  lzunicode,
  {$endif}
  u_nodes,
  u_parsenodes;

function  buildbasicelement(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql ):Boolean;
function  buildfieldconstraint(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildtableconstraint(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;

function  buildfield(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildtable(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;

        { TODO : build expression more precision }
function  buildselect(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  builddelete(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildupdate(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildinsert(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildinsertMySQL(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildcreatetable(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;

function  buildcreatetableMySQL(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildaltertableMySQL(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
function  buildselectwithwhere(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;


function  ppsql(psql : lzstring;dbvendor : TDBVendor) : lzstring;
function  checksqlastext(const oldsql,newsql : lzstring; dbvendor : TDBVendor; var resultstr : lzstring) : integer;




implementation

function  ppsql(psql : lzstring; dbvendor : TDbVendor) : lzstring;
var
  parser : TGsqlparser;
  i : integer;
begin
  parser := TGsqlparser.Create(dbvendor);
  try
    parser.SqlText.Add(psql);
    i := parser.PrettyPrint;
    if i = 0 then
      result := parser.FormattedSqlText.Text
    else
      result := 'pp error:'+return_code+parser.ErrorMessages+return_code+psql;
  finally
    parser.free;
  end;
end;

function  checksqlastext(const oldsql,newsql : lzstring; dbvendor : TDBVendor; var resultstr : lzstring) : integer;
var
  parser : TGsqlparser;
begin
  parser := TGsqlparser.Create(dbvendor);
  try
    parser.SqlText.Add(newsql);
    result := parser.PrettyPrint;
    if result = 0 then
      begin
        resultstr := parser.FormattedSqlText.Text;
        if not comparewithouttoken(oldsql,resultstr) then
          begin
            resultstr := dbvendorstr[dbvendor]+': new sql is different from old sql'
            +return_code+'old sql:'+return_code+oldsql
            +return_code+'new sql:'+return_code+newsql;
            result := -1;
          end;
      end
    else
      resultstr := dbvendorstr[dbvendor]+': new sql parse error:'+parser.ErrorMessages
      +return_code+'old sql:'+return_code+oldsql
      +return_code+'new sql:'+return_code+newsql;
  finally
    parser.free;
  end;
end;


function  buildbasicelement(var retStr : lzstring; pdbvendor : TDBVendor ):Boolean;
var
  lcsql : lzstring;
  lcstrs : Tlzstringlist;
  lcst : TSourceToken;
  lcat : TLz_attr;
  lcexpr : TLzCustomExpression;
//  lcpoint : TPoint;
begin
    lcstrs := Tlzstringlist.create;
    lcstrs.Add('scott'); // token
    lcstrs.Add('scott.emp'); //attr
    lcstrs.Add('(x+y-z)+1'); //expr
    lcst := TSourceToken.create(nil);
    lcat := TLz_attr.create(nil);
    lcexpr := TLzCustomExpression.Create(nil);

    try
      lcst.AsText := 'scott';

      lcat.relname := TSourceToken.create(lcat);
      lcat.relname.AsText := 'scott.emp';

      lcexpr.AsText := '(x+y-z)+1';

      lcsql := lcsql+return_code+lcst.AsText;
      lcsql := lcsql+return_code+lcat.AsText;
      lcsql := lcsql+return_code+lcexpr.AsText;

      retStr := lcsql;
      result := comparewithouttoken(lcsql,lcstrs.Text) ;
      if not result then
        retstr := retstr+return_code+'build error:'+return_code+lcstrs.text;

    finally
      lcst.free;
      lcat.free;
      lcstrs.Free;
      lcexpr.free;
    end;
end;


function  buildfieldconstraint(var retStr : lzstring; pdbvendor : TDBVendor ):Boolean;
var
  lcConstraintColumn: TLzConstraintColumn;
  lcsql : lzstring;
  lccnt : TLzConstraint;
  lcstrs : Tlzstringlist;
  lcattr1,lcattr2 : TLz_attr;
  lcst1,lcst2,lcst3 : TSourceToken;
//  lcpoint : TPoint;
  lcexpr1,lcexpr2 : TLzCustomExpression;
begin
    lcstrs := Tlzstringlist.create;
    //add all contraints need to be verified
    lcstrs.Add('not null');
    lcstrs.Add('null');
    lcstrs.Add('unique');
    lcstrs.Add('primary key');
    lcstrs.Add('check (col1>10)');
    lcstrs.Add('default 30');
    lcstrs.Add('references ab (col1,col2)');
    lcstrs.Add('references ab (col1,col2) on delete cascade');
    lcstrs.Add('auto_increment');

    //mssql dialects
    lcstrs.Add('unique clustered  on default');
    lcstrs.Add('primary key nonclustered on colname');
    lcstrs.Add('collate colname');
    lcstrs.Add('identity');
    lcstrs.Add('identity (expr1,expr2)');
    lcstrs.Add('default expr1 with values');
    lcstrs.Add('references scott.emp (col1,col2) on delete no action on update set null match partial');

    lccnt := TLzConstraint.Create(nil);
    try
      lccnt._keyword.AsText := '';
      lccnt._name.AsText := '';
		  lccnt.ConstraintLevel := clColumn;

      // not null
		  lccnt.ConstraintType := ctNotnull;
      lcsql := lcsql+return_code+lccnt.AsText;

      // null
		  lccnt.ConstraintType := ctnull;
      lcsql := lcsql+return_code+lccnt.AsText;

      // unique
		  lccnt.ConstraintType := ctunique;
      lcsql := lcsql+return_code+lccnt.AsText;

      // primary key
		  lccnt.ConstraintType := ctPrimarykey;
      lcsql := lcsql+return_code+lccnt.AsText;

      // check
		  lccnt.ConstraintType := ctCheck;
      lccnt.colexpr := TLzCustomExpression.Create(lccnt);
      lccnt.colexpr.astext := 'col1>10';
      lcsql := lcsql+return_code+lccnt.AsText;

      // default
		  lccnt.ConstraintType := ctDefault;
      lccnt.colexpr := TLzCustomExpression.Create(lccnt);
      lccnt.colexpr.astext := '30';
      lcsql := lcsql+return_code+lccnt.AsText;

      // reference
		  lccnt.ConstraintType := ctReference;
      lccnt.RefClause := TLzConstraintRefClause.Create(lccnt);
      lccnt.RefClause.q_name := TLz_attr.Create(lccnt);
      lccnt.RefClause.q_name.relname := TSourceToken.Create(lccnt);
      lccnt.RefClause.q_name.relname.AsText := 'ab';

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col1';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col2';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

//      lccnt.RefClause._column_listnode := TLz_dummynode.Create(lccnt);
//
//      lcst1 := TSourceToken.create(lccnt);
//      lcst1.AsText := '(';
//      lcst2 := TSourceToken.create(lccnt);
//      lcst2.AsText := ')';
//
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst1);
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst2);
//
//      lcattr1 := TLz_attr.Create(lccnt);
//      lcattr1.relname := TSourceToken.create(lccnt);
//      lcattr1.relname.AsText := 'col1';
//
//      lcattr2 := TLz_attr.Create(lccnt);
//      lcattr2.relname := TSourceToken.create(lccnt);
//      lcattr2.relname.AsText := 'col2';
//
//      lccnt.RefClause._column_listnode.list1 := TLz_list.Create(lccnt);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr1);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr2);

      lcsql := lcsql+return_code+lccnt.AsText;

      lccnt.RefClause.KeyAction := catDelete;
      lcst1 := TSourceToken.create(lccnt);
      lcst1.AsText := 'on';
      lcst2 := TSourceToken.create(lccnt);
      lcst2.AsText := 'delete';
      lcst3 := TSourceToken.create(lccnt);
      lcst3.AsText := 'cascade';

      lccnt.RefClause._keyactionnode := TLz_dummynode.Create(lccnt);
      lccnt.RefClause._keyactionnode.token1 := lcst1;
      lccnt.RefClause._keyactionnode.token2 := lcst2;
      lccnt.RefClause._keyactionnode.token3 := lcst3;

      lcsql := lcsql+return_code+lccnt.AsText;

      //auto_increment
		  lccnt.ConstraintType := ctMySQLAutoIncrement;
      lcsql := lcsql+return_code+lccnt.AsText;

      // mssql unique
		  lccnt.ConstraintType := ctunique;
      lccnt._stCluster := TSourceToken.Create(lccnt);
      lccnt._stCluster.AsText := 'clustered';

      lccnt._opt_onfilegroup := TLz_MssqlOnFileGroupClause.Create(lccnt);
      lccnt._opt_onfilegroup.AsText := 'on default';

      lcsql := lcsql+return_code+lccnt.AsText;

      // mssql primary key
		  lccnt.ConstraintType := ctprimarykey;
      lccnt._stCluster := TSourceToken.Create(lccnt);
      lccnt._stCluster.AsText := 'nonclustered';
      lccnt._opt_onfilegroup := TLz_MssqlOnFileGroupClause.Create(lccnt);
      lccnt._opt_onfilegroup.AsText := 'on colname';

      lcsql := lcsql+return_code+lccnt.AsText;

      //mssql collate
		  lccnt.ConstraintType := ctmssqlcollate;
      lccnt._Collatename := TSourceToken.Create(lccnt);
      lccnt._Collatename.AsText := 'colname';

      lcsql := lcsql+return_code+lccnt.AsText;

      //mssql identity
		  lccnt.ConstraintType := ctmssqlIdentity;
      lccnt.ColumnList := nil;
      lcsql := lcsql+return_code+lccnt.AsText;

      lccnt._ndIdentitySeed := TLzCustomExpression.Create(lccnt);
      lccnt._ndIdentitySeed.AsText := 'expr1';
      lccnt._ndIdentityIncrement := TLzCustomExpression.Create(lccnt);
      lccnt._ndIdentityIncrement.AsText := 'expr2';
//      lcexpr1 := TLzCustomExpression.Create(lccnt);
//      lcexpr1.AsText := 'expr1';
//      lcexpr2 := TLzCustomExpression.Create(lccnt);
//      lcexpr2.AsText := 'expr2';
//      lccnt.ColumnList := TLz_list.Create(lccnt);
//      lccnt.ColumnList.Add(lcexpr1);
//      lccnt.ColumnList.Add(lcexpr2);
      lcsql := lcsql+return_code+lccnt.AsText;

      // default
		  lccnt.ConstraintType := ctDefault;
      lccnt.colexpr := TLzCustomExpression.Create(lccnt);
      lccnt.colexpr.astext := 'expr1';
      lccnt._stWith := TSourceToken.Create(lccnt);
      lccnt._stWith.AsText := 'with';
      lccnt._stValues := TSourceToken.Create(lccnt);
      lccnt._stValues.AsText := 'values';

      lcsql := lcsql+return_code+lccnt.AsText;


      // reference
		  lccnt.ConstraintType := ctReference;
      lccnt.RefClause := TLzConstraintRefClause.Create(lccnt);
      lccnt.RefClause.q_name := TLz_attr.Create(lccnt);
      lccnt.RefClause.q_name.relname := TSourceToken.Create(lccnt);
      lccnt.RefClause.q_name.relname.AsText := 'scott.emp';

 //   lcstrs.Add('references scott.emp (col1,col2) match partial on delete on action on update set null');

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col1';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col2';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

//      lccnt.RefClause._column_listnode := TLz_dummynode.Create(lccnt);
//
//      lcst1 := TSourceToken.create(lccnt);
//      lcst1.AsText := '(';
//      lcst2 := TSourceToken.create(lccnt);
//      lcst2.AsText := ')';
//
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst1);
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst2);
//
//      lcattr1 := TLz_attr.Create(lccnt);
//      lcattr1.relname := TSourceToken.create(lccnt);
//      lcattr1.relname.AsText := 'col1';
//
//      lcattr2 := TLz_attr.Create(lccnt);
//      lcattr2.relname := TSourceToken.create(lccnt);
//      lcattr2.relname.AsText := 'col2';
//
//      lccnt.RefClause._column_listnode.list1 := TLz_list.Create(lccnt);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr1);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr2);

      lccnt.RefClause.KeyMatch :=  ckmPartial;
      lccnt.RefClause._keymatchnode := TLz_DummyNode.Create(lccnt);
      lccnt.RefClause._keymatchnode.token1 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keymatchnode.token1.AsText := 'match';
      lccnt.RefClause._keymatchnode.token2 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keymatchnode.token2.astext := 'partial';


      lccnt.RefClause.KeyAction := catDeleteUpdate;
      lccnt.RefClause._keyactionnode := TLz_dummynode.Create(lccnt);
      lccnt.RefClause._keyactionnode.token1 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token1.AsText := 'on';
      lccnt.RefClause._keyactionnode.token2 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token2.AsText := 'delete';
      lccnt.RefClause._keyactionnode.token3 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token3.AsText := 'no';
      lccnt.RefClause._keyactionnode.token4 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token4.AsText := 'action';
      lccnt.RefClause._keyactionnode.token5 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token5.AsText := 'on';
      lccnt.RefClause._keyactionnode.token6 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token6.AsText := 'update';
      lccnt.RefClause._keyactionnode.token7 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token7.AsText := 'set';
      lccnt.RefClause._keyactionnode.token8 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keyactionnode.token8.AsText := 'null';

      lcsql := lcsql+return_code+lccnt.AsText;

      result := comparewithouttoken(lcsql,lcstrs.Text) ;

      if not result then
        lcsql := 'error'+return_code+lcsql+return_code+'build sql error'+return_code+lcstrs.text;

      retStr := lcsql;
    finally
      lccnt.free;
      lcstrs.Free;
    end;
end;

function  buildtableconstraint(var retStr : lzstring; pdbvendor : TDBVendor ):boolean;
var
  lcConstraintColumn: TLzConstraintColumn;
  lcsql : lzstring;
  lccnt : TLzConstraint;
  lcstrs : Tlzstringlist;
  lcattr1,lcattr2 : TLz_attr;
  lcst1,lcst2,lcst3 : TSourceToken;
//  lcpoint : TPoint;
begin

    lcstrs := Tlzstringlist.create;
    //add all contraints need to be verified
    lcstrs.Add('check (col1 = 1)');
    lcstrs.Add('unique (col1,col2)');
    lcstrs.Add('primary key (col1,col2)');
    lcstrs.Add('foreign key  (col1,col2)');
    lcstrs.Add('foreign key keyname (col1,col2) references scott.dept (col3,col4) on update restrict match full');
    lcstrs.Add('key (col1,col2)');
    lcstrs.Add('index indexname (col1,col2)');
    //mssql dialects
    lcstrs.Add('unique clustered (col1,col2) on default');
    lcstrs.Add('primary key nonclustered (col1,col2) on colname');
    lcstrs.Add('foreign key  (col1,col2) references scott.emp');


    lccnt := TLzConstraint.Create(nil);
    try
      lccnt._keyword.AsText := '';
      lccnt._name.AsText := '';
		  lccnt.ConstraintLevel := clTable;


      // check
		  lccnt.ConstraintType := ctCheck;
      lccnt.colexpr := TLzCustomExpression.Create(lccnt);
      lccnt.colexpr.astext := 'col1=1';
      lcsql := lcsql+return_code+lccnt.AsText;

      // unique
		  lccnt.ConstraintType := ctunique;


      lccnt.ColumnNameList.AsText := 'col1,col2';

      lcsql := lcsql+return_code+lccnt.AsText;


      // primary key
		  lccnt.ConstraintType := ctPrimarykey;
      lcsql := lcsql+return_code+lccnt.AsText;

      // foreign key
		  lccnt.ConstraintType := ctForeignkey;
      lcsql := lcsql+return_code+lccnt.AsText;

      // foreign key with references
		  lccnt.ConstraintType := ctForeignkey;
      lccnt._stMySQLIndexName := TSourceToken.Create(lccnt);
      lccnt._stMySQLIndexName.AsText := 'keyname';

//      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
//      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
//      lcConstraintColumn.ColumnName.AsText := 'col1';
//      lccnt.ConstraintColumnList.Add(lcConstraintColumn);
//
//      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
//      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
//      lcConstraintColumn.ColumnName.AsText := 'col2';
//      lccnt.ConstraintColumnList.Add(lcConstraintColumn);

//      lccnt.ColumnList := TLz_list.Create(lccnt);
//
//      lcattr1 := TLz_attr.Create(lccnt);
//      lcattr1.relname := TSourceToken.Create(lccnt);
//      lcattr1.relname.AsText := 'col1';
//
//      lcattr2 := TLz_attr.Create(lccnt);
//      lcattr2.relname := TSourceToken.Create(lccnt);
//      lcattr2.relname.AsText := 'col2';
//
//      lccnt.ColumnList.Add(lcattr1);
//      lccnt.ColumnList.Add(lcattr2);


      lccnt.RefClause := TLzConstraintRefClause.Create(lccnt);
      lccnt.RefClause.q_name := TLz_attr.Create(lccnt);
      lccnt.RefClause.q_name.relname := TSourceToken.Create(lccnt);
      lccnt.RefClause.q_name.relname.AsText := 'scott.dept';

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col3';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

      lcConstraintColumn := TLzConstraintColumn.Create(lccnt);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccnt);
      lcConstraintColumn.ColumnName.AsText := 'col4';
      lccnt.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

//      lccnt.RefClause._column_listnode := TLz_dummynode.Create(lccnt);
//
//      lcst1 := TSourceToken.create(lccnt);
//      lcst1.AsText := '(';
//      lcst2 := TSourceToken.create(lccnt);
//      lcst2.AsText := ')';
//
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst1);
//      lccnt.RefClause._column_listnode.RawTokens.Add(lcst2);
//
//      lcattr1 := TLz_attr.Create(lccnt);
//      lcattr1.relname := TSourceToken.create(lccnt);
//      lcattr1.relname.AsText := 'col3';
//
//      lcattr2 := TLz_attr.Create(lccnt);
//      lcattr2.relname := TSourceToken.create(lccnt);
//      lcattr2.relname.AsText := 'col4';
//
//      lccnt.RefClause._column_listnode.list1 := TLz_list.Create(lccnt);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr1);
//      lccnt.RefClause._column_listnode.list1.Add(lcattr2);


      lccnt.RefClause.KeyMatch :=  ckmFull;
      lccnt.RefClause._keymatchnode := TLz_DummyNode.Create(lccnt);
      lccnt.RefClause._keymatchnode.token1 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keymatchnode.token1.AsText := 'match';
      lccnt.RefClause._keymatchnode.token2 := TSourceToken.Create(lccnt);
      lccnt.RefClause._keymatchnode.token2.astext := 'full';


      lccnt.RefClause.KeyAction := catUpdate;
      lcst1 := TSourceToken.create(lccnt);
      lcst1.AsText := 'on';
      lcst2 := TSourceToken.create(lccnt);
      lcst2.AsText := 'update';
      lcst3 := TSourceToken.create(lccnt);
      lcst3.AsText := 'restrict';

      lccnt.RefClause._keyactionnode := TLz_dummynode.Create(lccnt);
      lccnt.RefClause._keyactionnode.token1 := lcst1;
      lccnt.RefClause._keyactionnode.token2 := lcst2;
      lccnt.RefClause._keyactionnode.token3 := lcst3;

      lcsql := lcsql+return_code+lccnt.AsText;

      // mysql key
		  lccnt.ConstraintType := ctMysqlKey;
      lccnt._stMySQLIndexName := nil;
      lcsql := lcsql+return_code+lccnt.AsText;

      // mysql index
		  lccnt.ConstraintType := ctMysqlIndex;
      lccnt._stMySQLIndexName := TSourceToken.Create(lccnt);
      lccnt._stMySQLIndexName.AsText := 'indexname';
      lcsql := lcsql+return_code+lccnt.AsText;


      // mssql unique
		  lccnt.ConstraintType := ctunique;
      lccnt._stCluster := TSourceToken.Create(lccnt);
      lccnt._stCluster.AsText := 'clustered';
      lccnt._opt_onfilegroup := TLz_MssqlOnFileGroupClause.Create(lccnt);
      lccnt._opt_onfilegroup.AsText := 'on default';
      lccnt._stMySQLIndexName := nil;

      lcsql := lcsql+return_code+lccnt.AsText;

      // mssql primary key
		  lccnt.ConstraintType := ctprimarykey;
      lccnt._stCluster := TSourceToken.Create(lccnt);
      lccnt._stCluster.AsText := 'nonclustered';
      lccnt._opt_onfilegroup := TLz_MssqlOnFileGroupClause.Create(lccnt);
      lccnt._opt_onfilegroup.AsText := 'on colname';
      lccnt._stMySQLIndexName := nil;

      lcsql := lcsql+return_code+lccnt.AsText;


      // foreign key with references
		  lccnt.ConstraintType := ctForeignkey;
      lccnt.RefClause := nil;
      lccnt._stMySQLIndexName := nil;

      lccnt.ColumnList := TLz_list.Create(lccnt);

      lcattr1 := TLz_attr.Create(lccnt);
      lcattr1.relname := TSourceToken.Create(lccnt);
      lcattr1.relname.AsText := 'col1';

      lcattr2 := TLz_attr.Create(lccnt);
      lcattr2.relname := TSourceToken.Create(lccnt);
      lcattr2.relname.AsText := 'col2';

      lccnt.ColumnList.Add(lcattr1);
      lccnt.ColumnList.Add(lcattr2);

      lccnt.RefClause := TLzConstraintRefClause.Create(lccnt);
      lccnt.RefClause.q_name := TLz_attr.Create(lccnt);
      lccnt.RefClause.q_name.relname := TSourceToken.Create(lccnt);
      lccnt.RefClause.q_name.relname.AsText := 'scott.emp';
      lccnt.RefClause._column_listnode := nil;

      lcsql := lcsql+return_code+lccnt.AsText;

      result := comparewithouttoken(lcsql,lcstrs.Text) ;

      if not result then
        lcsql := lcsql+return_code+return_code+'*********build sql error**********'+return_code+lcstrs.text;

      retStr := lcsql;
    finally
      lccnt.free;
      lcstrs.Free;
    end;
end;

function  buildfield(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  lcstrs : Tlzstringlist;
  lcfield : TLzField;
  lcsql : Lzstring;
  lccn : TLzConstraint;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('field1');
    lcstrs.Add('field1 aliasname');
    lcstrs.Add('user1.field1 aliasname');
    lcstrs.Add('field1 as aliasname');
    lcstrs.Add('field1 char(1)');
    lcstrs.Add('field1 char(1) not null');
    lcstrs.Add('field1 char(1) not null default 10');

    lcfield := TLzField.create(nil);
    try
      lcfield.fieldname := 'field1';
      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

    lcfield := TLzField.create(nil);
    try
      lcfield.FieldName := 'field1';
      lcfield.aliasclause := TLz_AliasClause.Create(lcfield);
      lcfield.aliasclause._aliastoken := TSourceToken.Create(lcfield);
      lcfield.aliasclause._aliastoken.AsText := 'aliasname';

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

    lcfield := TLzField.create(nil);
    try
      lcfield.FieldName := 'field1';
      lcfield.Fieldprefix := 'user1';
      lcfield.aliasclause := TLz_AliasClause.Create(lcfield);
      lcfield.aliasclause._aliastoken := TSourceToken.Create(lcfield);
      lcfield.aliasclause._aliastoken.AsText := 'aliasname';

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

    lcfield := TLzField.create(nil);
    try
      lcfield.FieldName := 'field1';
      lcfield.aliasclause := TLz_AliasClause.Create(lcfield);
      lcfield.aliasclause._aliastoken := TSourceToken.Create(lcfield);
      lcfield.aliasclause._aliastoken.AsText := 'aliasname';
      lcfield.aliasclause._withas := true;

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

    lcfield := TLzField.create(nil);
    try
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcfield);
      lcfield.ColumnName.AsText := 'field1';
      lcfield.FieldDataType := TLz_typename.Create(lcfield);
      lcfield.FieldDataType.AsText := 'char(1)';

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

    lcfield := TLzField.create(nil);
    try
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcfield);
      lcfield.ColumnName.AsText := 'field1';
      lcfield.FieldDataType := TLz_typename.Create(lcfield);
      lcfield.FieldDataType.AsText := 'char(1)';
      lccn := TLzConstraint.Create(lcfield);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctNotnull;
      lcfield.ColumnConstraints.Add(lccn);

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;


    lcfield := TLzField.create(nil);
    try
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcfield);
      lcfield.ColumnName.AsText := 'field1';
      lcfield.FieldDataType := TLz_typename.Create(lcfield);
      lcfield.FieldDataType.AsText := 'char(1)';

      lccn := TLzConstraint.Create(lcfield);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctNotnull;
      lcfield.ColumnConstraints.Add(lccn);

      lccn := TLzConstraint.Create(lcfield);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctDefault;
      lccn.colexpr := TLzCustomExpression.Create(lccn);
      lccn.colexpr.astext := '10';

      lcfield.ColumnConstraints.Add(lccn);

      lcsql := lcsql+return_code+lcfield.AsText;
    finally
      lcfield.free;
    end;

      result := comparewithouttoken(lcsql,lcstrs.Text) ;

      if not result then
        lcsql := lcsql+return_code+return_code+'*********build sql error:'+return_code+lcstrs.text;

      retStr := lcsql;

  finally
    lcstrs.free;
  end;

end;

function  buildtable(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  lcstrs : Tlzstringlist;
  lctable : TLzTable;
  lcsql : Lzstring;
//  lccn : TLzConstraint;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('table1');
    lcstrs.Add('table1 aliasname');
    lcstrs.Add('user1.table1 aliasname');
    lcstrs.Add('table1 as aliasname');
    lcstrs.Add('func(p1,p2)');
    lcstrs.Add('(select f1,f2 from subtable1)');
    lcstrs.Add('(select f1,f2 from subtable2)');

    lctable := TLzTable.create(nil);
    try
      lctable.tablename := 'table1';
      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.tableName := 'table1';
      lctable.aliasclause := TLz_AliasClause.Create(lctable);
      lctable.aliasclause._aliastoken := TSourceToken.Create(lctable);
      lctable.aliasclause._aliastoken.AsText := 'aliasname';

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.tableName := 'table1';
      lctable.tableprefix := 'user1';
      lctable.aliasclause := TLz_AliasClause.Create(lctable);
      lctable.aliasclause._aliastoken := TSourceToken.Create(lctable);
      lctable.aliasclause._aliastoken.AsText := 'aliasname';

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.tableName := 'table1';
      lctable.aliasclause := TLz_AliasClause.Create(lctable);
      lctable.aliasclause._aliastoken := TSourceToken.Create(lctable);
      lctable.aliasclause._aliastoken.AsText := 'aliasname';
      lctable.aliasclause._withas := true;

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.tablename := 'func(p1,p2)';
      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.tablename := '(select f1,f2 from subtable1)';
      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.TableType := lttSubquery;
      lctable.SubQuery := TSelectSqlStatement.create(dbvoracle);
      lctable.SubQuery.AsText := '(select f1,f2 from subtable2)';
      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.SubQuery.Free;
      lctable.free;

    end;


{

    lctable := TLzTable.create(nil);
    try
      lctable.IsColumnDef := true;
      lctable.ColumnName := TSourceToken.Create(lctable);
      lctable.ColumnName.AsText := 'field1';
      lctable.FieldDataType := TLz_typename.Create(lctable);
      lctable.FieldDataType.AsText := 'char(1)';

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

    lctable := TLzTable.create(nil);
    try
      lctable.IsColumnDef := true;
      lctable.ColumnName := TSourceToken.Create(lctable);
      lctable.ColumnName.AsText := 'field1';
      lctable.FieldDataType := TLz_typename.Create(lctable);
      lctable.FieldDataType.AsText := 'char(1)';
      lccn := TLzConstraint.Create(lctable);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctNotnull;
      lctable.ColumnConstraints.Add(lccn);

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;


    lctable := TLzTable.create(nil);
    try
      lctable.IsColumnDef := true;
      lctable.ColumnName := TSourceToken.Create(lctable);
      lctable.ColumnName.AsText := 'field1';
      lctable.FieldDataType := TLz_typename.Create(lctable);
      lctable.FieldDataType.AsText := 'char(1)';

      lccn := TLzConstraint.Create(lctable);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctNotnull;
      lctable.ColumnConstraints.Add(lccn);

      lccn := TLzConstraint.Create(lctable);
      lccn.ConstraintLevel := clcolumn;
      lccn.ConstraintType := ctDefault;
      lccn.colexpr := TLzCustomExpression.Create(lccn);
      lccn.colexpr.astext := '10';

      lctable.ColumnConstraints.Add(lccn);

      lcsql := lcsql+return_code+lctable.AsText;
    finally
      lctable.free;
    end;

}
      result := comparewithouttoken(lcsql,lcstrs.Text) ;

      if not result then
        lcsql := lcsql+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := lcsql;

  finally
    lcstrs.free;
  end;
end;


function  buildaltertableMySQL(var retStr : lzstring; pdbvendor : TDBVendor ):boolean;
var
  lcConstraintColumn: TLzConstraintColumn;
  at : TAlterTableStatement;
  ato : TLzAlterTableOption;
  fd : TLzField;
  lcstrs : Tlzstringlist;
  lcsql,pptext : lzstring;
  lcst,lcst1,lcst2,lcst3 : TSourceToken;
  lccn : TLzConstraint;
  lcat,lcattr1,lcattr2 : Tlz_attr;
begin

  lcstrs := Tlzstringlist.Create;
  lcstrs.Add('alter table tablename add colname char(2);');
  lcstrs.Add('alter table tablename add column colname char(2) first;');
  lcstrs.Add('alter table tablename add column colname char(2) after col2;');
  lcstrs.Add('alter table tablename add (col1 char(2), col2 int not null);');
  lcstrs.Add('alter table tablename add index(col1,col2);');
  lcstrs.Add('alter table tablename add primary key (col1,col2);');
  lcstrs.Add('alter table tablename add constraint conname primary key (col1,col2);');
  lcstrs.Add('alter table tablename add constraint conname unique u_name (col1,col2);');
  lcstrs.Add('alter table tablename add constraint conname foreign key (col1,col2);');
  lcstrs.Add('alter table tablename add constraint conname foreign key (col1,col2) references scott.emp(f1,f2) on update cascade;');
  try

    at := TAlterTableStatement.Create(pdbvendor);// DbvMysql
    try
     at.Table := TLzTable.Create(at);
     at.Table.AsText := 'tablename';
     ato := TLzAlterTableOption.Create(at);
     ato.atOption := atoAddColumn;
     ato._withparens := false;
     fd := TLzField.Create(at);
     fd.FieldType := lftColumn;
     fd.ColumnName := TSourceToken.Create(at);
     fd.ColumnName.AsText := 'colname';
     fd.FieldDataType := TLz_typename.Create(at);
     fd.FieldDataType.AsText := 'char(2)';

     ato.Fields.Add(fd);
     at.AlterTableOptionList.Add(ato);

     lcsql := at.AsText+';';

     ato.opt_rw_column := TSourceToken.Create(ato);
     ato.opt_rw_column.AsText := 'column';
     ato.opt_first_after := TLz_dummynode.Create(ato);
     lcst := TSourceToken.Create(ato);
     lcst.AsText := 'first';
     ato.opt_first_after.RawTokens.Add(lcst);

     lcsql := lcsql+return_code+at.AsText+';';

     ato.opt_first_after.RawTokens.Clear;
     lcst := TSourceToken.Create(ato);
     lcst.AsText := 'after';
     ato.opt_first_after.RawTokens.Add(lcst);
     lcst := TSourceToken.Create(ato);
     lcst.AsText := 'col2';
     ato.opt_first_after.RawTokens.Add(lcst);

     lcsql := lcsql+return_code+at.AsText+';';

    finally
      at.free;
    end;


    at := TAlterTableStatement.Create(pdbvendor);//DbvMysql
    try
     at.Table := TLzTable.Create(at);
     at.Table.AsText := 'tablename';
     ato := TLzAlterTableOption.Create(at);
     ato.atOption := atoAddColumn;
     ato._withparens := true;

     fd := TLzField.Create(at);
     fd.FieldType := lftColumn;
     fd.ColumnName := TSourceToken.Create(at);
     fd.ColumnName.AsText := 'col1';
     fd.FieldDataType := TLz_typename.Create(at);
     fd.FieldDataType.AsText := 'char(2)';
     ato.Fields.Add(fd);

     fd := TLzField.Create(at);
     fd.FieldType := lftColumn;
     fd.ColumnName := TSourceToken.Create(at);
     fd.ColumnName.AsText := 'col2';
     fd.FieldDataType := TLz_typename.Create(at);
     fd.FieldDataType.AsText := 'int';
     lccn := TLzConstraint.Create(fd);
     lccn.ConstraintLevel := clcolumn;
     lccn.ConstraintType := ctNotnull;
     fd.ColumnConstraints.Add(lccn);


     ato.Fields.Add(fd);

     at.AlterTableOptionList.Add(ato);


     lcsql := lcsql+return_code+at.AsText+';';

    finally
      at.free;
    end;

   //add index
    at := TAlterTableStatement.Create(pdbvendor); //DbvMysql
    try
     at.Table := TLzTable.Create(at);
     at.Table.AsText := 'tablename';
     ato := TLzAlterTableOption.Create(at);
     ato.atOption := atoAddConstraintIndex;


     ato.ColumnNameList.AsText := 'col1,col2';
     at.AlterTableOptionList.Add(ato);


     lcsql := lcsql+return_code+at.AsText+';';

    finally
      at.free;
    end;

   //add primary key
    at := TAlterTableStatement.Create(pdbvendor); //DbvMysql
    try
     at.Table := TLzTable.Create(at);
     at.Table.AsText := 'tablename';
     ato := TLzAlterTableOption.Create(at);
     ato.atOption := atoAddConstraintPk;

     ato.ColumnNameList.AsText := 'col1,col2';

     at.AlterTableOptionList.Add(ato);


     lcsql := lcsql+return_code+at.AsText+';';

     ato.opt_constraint_with_name := TLz_dummynode.Create(at);
     lcst := TSourceToken.Create(at);
     lcst.AsText := 'constraint';
     ato.opt_constraint_with_name.RawTokens.Add(lcst);

     lcst := TSourceToken.Create(at);
     lcst.AsText := 'conname';
     ato.opt_constraint_with_name.RawTokens.Add(lcst);

     lcsql := lcsql+return_code+at.AsText+';';

     ato.atOption := atoAddConstraintUnique;
     ato.opt_name := TSourceToken.Create(at);
     ato.opt_name.AsText := 'u_name';
     lcsql := lcsql+return_code+at.AsText+';';

     ato.atOption := atoAddConstraintFk;
     lcsql := lcsql+return_code+at.AsText+';';

     //foreign key with references
      ato.RefClause := TLzConstraintRefClause.Create(at);
      ato.RefClause.q_name := TLz_attr.Create(at);
      ato.RefClause.q_name.relname := TSourceToken.Create(at);
      ato.RefClause.q_name.relname.AsText := 'scott.emp';

      lcConstraintColumn := TLzConstraintColumn.Create(at);
      lcConstraintColumn.ColumnName := TLz_attr.Create(at);
      lcConstraintColumn.ColumnName.AsText := 'f1';
      ato.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

      lcConstraintColumn := TLzConstraintColumn.Create(at);
      lcConstraintColumn.ColumnName := TLz_attr.Create(at);
      lcConstraintColumn.ColumnName.AsText := 'f2';
      ato.RefClause.ConstraintColumnList.Add(lcConstraintColumn);

//      ato.RefClause._column_listnode := TLz_dummynode.Create(at);
//
//      lcst1 := TSourceToken.create(at);
//      lcst1.AsText := '(';
//      lcst2 := TSourceToken.create(at);
//      lcst2.AsText := ')';
//
//      ato.RefClause._column_listnode.RawTokens.Add(lcst1);
//      ato.RefClause._column_listnode.RawTokens.Add(lcst2);
//
//      lcattr1 := TLz_attr.Create(at);
//      lcattr1.relname := TSourceToken.create(at);
//      lcattr1.relname.AsText := 'f1';
//
//      lcattr2 := TLz_attr.Create(at);
//      lcattr2.relname := TSourceToken.create(at);
//      lcattr2.relname.AsText := 'f2';
//
//      ato.RefClause._column_listnode.list1 := TLz_list.Create(at);
//      ato.RefClause._column_listnode.list1.Add(lcattr1);
//      ato.RefClause._column_listnode.list1.Add(lcattr2);


      ato.RefClause.KeyAction := catUpdate;
      lcst1 := TSourceToken.create(at);
      lcst1.AsText := 'on';
      lcst2 := TSourceToken.create(at);
      lcst2.AsText := 'update';
      lcst3 := TSourceToken.create(at);
      lcst3.AsText := 'cascade';

      ato.RefClause._keyactionnode := TLz_dummynode.Create(at);
      ato.RefClause._keyactionnode.token1 := lcst1;
      ato.RefClause._keyactionnode.token2 := lcst2;
      ato.RefClause._keyactionnode.token3 := lcst3;

      lcsql := lcsql+return_code+at.AsText+';';

    finally
      at.free;
    end;

      pptext := ppsql(lcsql,pdbvendor); //DbvMysql
      result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'****build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

finally
  lcstrs.free;
end;

end;

function  buildselect(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  select,leftquery,rightquery : TSelectSqlStatement;
//  ato : TLzAlterTableOption;
  fd,fd2,fd3 : TLzField;
  ji,ji2 : TLzJoin;
  jit,jit2 : TLzJoinItem;
  lcstrs : Tlzstringlist;
  lcsql,pptext : lzstring;
  lcst : TSourceToken;
//  lccn : TLzConstraint;
//  lcat,lcattr1,lcattr2 : Tlz_attr;
  lcexpr : TLzCustomExpression;
  lcOrderby : TLzOrderBy;
begin

  lcstrs := Tlzstringlist.Create;

  lcstrs.Add('select varname;');
  lcstrs.Add('select empno no,empname as ename from emp;');
  lcstrs.Add('select e.ename empname,d.id as deptid from emp e, dept d where e.deptid = d.id;');
  lcstrs.Add('select e.ename empname,d.id as deptid from emp e join dept d on e.deptid = d.id;');
  lcstrs.Add('select t1.f1 from my.table1 t1 join (my.table2 t2 left join my.table3 t3 on t2.f1 = t3.f1) as joinalias1 on t1.f1 = t2.f1;');

  lcstrs.Add('select f1,(select f2 from t2) from emp;');
  lcstrs.Add('select f1,(select f2 from t2) f2 from emp as t1, (select f3 from t3) as t2;');

  lcstrs.Add('select distinct empname  from emp; ');
  lcstrs.Add('select top 10 empname into @var from emp where f1>10  group by f1,f2 having f2 = 1 order by f1 asc, f2 desc , f3;');

  lcstrs.Add('select empname from emp union select deptname from dept; ');
  lcstrs.Add('select empname from emp union  all select deptname from dept; ');
  lcstrs.Add('select empname from emp minus select deptname from dept; ');
  lcstrs.Add('select empname from emp intersect select deptname from dept; ');

  lcstrs.Add('select empname from emp intersect select deptname from dept order by f1;');

try
    // select varname; valid in mssql, mysql
    select := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'varname';
      select.Fields.Add(fd);
      // result := checksqlastext('',select.AsText,pdbvendor,retstr) = 0;
      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;

    select := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'empno';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'no';
      select.Fields.Add(fd);

      fd := TLzField.Create(select);
      fd.FieldName := 'empname';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'ename';
      fd.aliasclause._withas := true;
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      select.JoinTables.Add(ji);

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;


   // select e.ename empname,d.id as deptid from emp e, dept d where e.deptid = d.id;
    select := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'ename';
      fd.FieldPrefix := 'e';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'empname';
      select.Fields.Add(fd);

      fd := TLzField.Create(select);
      fd.FieldName := 'id';
      fd.FieldPrefix := 'd';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'deptid';
      fd.aliasclause._withas := true;
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      ji.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
      ji.JoinTable.aliasclause._aliastoken.AsText := 'e';
      select.JoinTables.Add(ji);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'dept';
      ji.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
      ji.JoinTable.aliasclause._aliastoken.AsText := 'd';
      select.JoinTables.Add(ji);

      select.WhereClauseText := 'e.deptid = d.id';

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;


   // select e.ename empname,d.id as deptid from emp e join dept d on e.deptid = d.id
    select := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'ename';
      fd.FieldPrefix := 'e';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'empname';
      select.Fields.Add(fd);

      fd := TLzField.Create(select);
      fd.FieldName := 'id';
      fd.FieldPrefix := 'd';
      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'deptid';
      fd.aliasclause._withas := true;
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      ji.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
      ji.JoinTable.aliasclause._aliastoken.AsText := 'e';

      jit := TLzJoinItem.Create(select);
      jit.JoinItemTableType := jttTable;
//      lcst := TSourceToken.create(select);
//      lcst.AsText := 'join';
//      jit.RawTokens.Add(lcst);
      jit.JoinItemTable := TLzTable.Create(select);
      jit.JoinItemTable.TableName := 'dept';
      jit.JoinItemTable.aliasclause := Tlz_aliasclause.Create(select);
      jit.JoinItemTable.aliasclause._aliastoken := TSourceToken.create(select);
      jit.JoinItemTable.aliasclause._aliastoken.AsText := 'd';
      jit.JoinType := sjtjoininner;

      jit.JoinQual := TLzCustomExpression.Create(select);
      jit.JoinQualType := sjqOn;
      jit.JoinQual.AsText := 'e.deptid = d.id';

      ji.JoinItems.Add(jit);
      select.JoinTables.Add(ji);


      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;


  //  select t1.f1 from my.table1 t1 join (my.table2 t2 left join my.table3 t3 on t2.f1 = t3.f1) as joinalias1 on t1.f1 = t2.f1;
    select := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'f1';
      fd.FieldPrefix := 't1';
      fd.aliasclause := TLz_aliasclause.Create(select);
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);

      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'table1';
      ji.JoinTable.TablePrefix := 'my';
      ji.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
      ji.JoinTable.aliasclause._aliastoken.AsText := 't1';

      jit := TLzJoinItem.Create(select);
      jit.JoinItemTableType := jttJoin;
      jit.JoinType :=   sjtjoininner;
//      lcst := TSourceToken.create(select);
//      lcst.AsText := 'join';
//      jit.RawTokens.Add(lcst);
      jit.JoinQual := TLzCustomExpression.Create(select);
      jit.JoinQualType := sjqOn;
      jit.JoinQual.AsText := 't1.f1 = t2.f1';

        jit.JoinItemJoin := TLzJoin.Create(select);
        jit.JoinItemJoin.NestedLevel := 1;
        jit.joinitemjoin.newalias := TLz_AliasClause.Create(select);
        jit.joinitemjoin.newalias._aliastoken := TSourceToken.Create(select);
        jit.JoinItemJoin.newalias._aliastoken.AsText := 'joinalias1';
        jit.JoinItemJoin.newalias._withas := true;

        jit.JoinItemJoin.JoinTable := TLzTable.Create(select);
        jit.JoinItemJoin.JoinTable.TableName := 'table2';
        jit.JoinItemJoin.JoinTable.TablePrefix := 'my';
        jit.JoinItemJoin.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
        jit.JoinItemJoin.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
        jit.JoinItemJoin.JoinTable.aliasclause._aliastoken.AsText := 't2';

        jit2 := TLzJoinItem.Create(select);
        jit2.JoinItemTableType := jttTable;
//        lcst := TSourceToken.create(select);
//        lcst.AsText := 'left';
//        jit2.RawTokens.Add(lcst);
//        lcst := TSourceToken.create(select);
//        lcst.AsText := 'join';
//        jit2.RawTokens.Add(lcst);

        jit2.JoinType := sjtleft;

        jit2.JoinItemTable := TLzTable.Create(select);
        jit2.JoinItemTable.TableName := 'table3';
        jit2.JoinItemTable.TablePrefix := 'my';
        jit2.JoinItemTable.aliasclause := Tlz_aliasclause.Create(select);
        jit2.JoinItemTable.aliasclause._aliastoken := TSourceToken.create(select);
        jit2.JoinItemTable.aliasclause._aliastoken.AsText := 't3';

        jit2.JoinQual := TLzCustomExpression.Create(select);
        jit2.JoinQualType := sjqOn;
        jit2.JoinQual.AsText := 't2.f1 = t3.f1';

        jit.JoinItemJoin.JoinItems.Add(jit2);

      ji.JoinItems.Add(jit);
      select.JoinTables.Add(ji);


      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;

  // select f1,(select f2 from t2) from emp;

    select := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'f1';
      select.Fields.Add(fd);

      fd := TLzField.Create(select);
      fd.FieldType := lftSubquery;
      fd.SubQuery := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
      fd.SubQuery.IsParsed := true;
      TSelectSqlStatement(fd.SubQuery).WithParenthesis := 1;

      // create subquery
        fd2 := TLzField.Create(fd.SubQuery);
        fd2.FieldName := 'f2';
        fd.SubQuery.Fields.Add(fd2);
        ji2 := TLzJoin.Create(fd.SubQuery);
        ji2.JoinTable := TLzTable.Create(fd.SubQuery);
        ji2.JoinTable.TableName := 't2';
        TSelectSqlStatement(fd.SubQuery).JoinTables.Add(ji2);

      // end of create subquery

      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      select.JoinTables.Add(ji);

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      fd.SubQuery.free;
      select.free;
    end;

  // select f1,(select f2 from t2) f2 from emp as t1, (select f3 from t3) as t2;
    select := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'f1';
      select.Fields.Add(fd);

      fd := TLzField.Create(select);
      fd.FieldType := lftSubquery;
      fd.SubQuery := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
      TSelectSqlStatement(fd.SubQuery).IsParsed := true;
      TSelectSqlStatement(fd.SubQuery).WithParenthesis := 1;

      // create subquery
        fd2 := TLzField.Create(fd.SubQuery);
        fd2.FieldName := 'f2';
        fd.SubQuery.Fields.Add(fd2);
        ji2 := TLzJoin.Create(fd.SubQuery);
        ji2.JoinTable := TLzTable.Create(fd.SubQuery);
        ji2.JoinTable.TableName := 't2';
        TSelectSqlStatement(fd.SubQuery).JoinTables.Add(ji2);
      // end of create subquery

      fd.aliasclause := TLz_aliasclause.Create(select);
      fd.aliasclause._aliastoken := TSourceToken.Create(select);
      fd.aliasclause._aliastoken.AsText := 'f2';

      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      ji.JoinTable.aliasclause := TLz_aliasclause.Create(ji);
      ji.JoinTable.aliasclause._withas := true;
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.Create(ji);
      ji.JoinTable.aliasclause._aliastoken.astext := 't1';

      select.JoinTables.Add(ji);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableType := lttSubquery;
      // create subquery
      ji.JoinTable.SubQuery := TSelectSqlStatement.Create(pdbvendor); //dbvmssql
      TSelectSqlStatement(ji.JoinTable.SubQuery).IsParsed := true;
      TSelectSqlStatement(ji.JoinTable.SubQuery).WithParenthesis := 1;
      ji.JoinTable.aliasclause := TLz_aliasclause.Create(ji);
      ji.JoinTable.aliasclause._withas := true;
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.Create(ji);
      ji.JoinTable.aliasclause._aliastoken.astext := 't2';

      fd3 := TLzField.Create(ji.JoinTable.SubQuery);
      fd3.FieldName := 'f3';
      ji.JoinTable.SubQuery.Fields.Add(fd3);

      ji2 := TLzJoin.Create(ji.JoinTable.SubQuery);
      ji2.JoinTable := TLzTable.Create(ji.JoinTable.SubQuery);
      ji2.JoinTable.TableName := 't3';
      TSelectSqlStatement(ji.JoinTable.SubQuery).JoinTables.Add(ji2);

      // end of create subquery

      select.JoinTables.Add(ji);

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      fd.SubQuery.free;
      ji.JoinTable.SubQuery.free;
      select.free;
    end;

   // select distinct empname  from emp ;

    select := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    try
      select.IsParsed := true; // must be set to true
      select.SelectDistinctText := 'distinct';

      fd := TLzField.Create(select);
      fd.FieldName := 'empname';
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';

      select.JoinTables.Add(ji);

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.free;
    end;


   // select top 10 empname into @var from emp where f1>10 having f2 = 1 group by f1,f2 order by f1 asc, order by f2 desc , order by f3

    select := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    try
      select.IsParsed := true; // must be set to true
      select.topclauseText := 'top 10';
      select.IntoClauseAsText := '@var';
     // select.IntoClause := TLzCustomExpression.Create(select);
     // select.IntoClause.AsText := '@var';

      fd := TLzField.Create(select);
      fd.FieldName := 'empname';
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';

      select.JoinTables.Add(ji);

      select.WhereClause := TLzcustomExpression.Create(select);
      select.WhereClause.AsText := 'f1>10';

      select.HavingClause := TLzcustomExpression.Create(select);
      select.HavingClause.AsText := 'f2 = 1';


      select.GroupbyClause := TLzGroupBy.Create(select);//TLzcustomExpression.Create(select,select.DBVendor,'f1,f2');
      select.GroupbyClause.AsText := 'group by f1,f2';
      {      select.GroupbyClause.oper := Expr_exprlist;
      select.GroupbyClause.lexpr := TLz_list.Create(select);
      lcexpr := TlzcustomExpression.Create(select);
      lcexpr.AsText := 'f1';
      TLz_list(select.GroupbyClause.lexpr).Add(lcexpr);
      lcexpr := TlzcustomExpression.Create(select);
      lcexpr.AsText := 'f2';
      TLz_list(select.GroupbyClause.lexpr).Add(lcexpr);
 }
     
      //or, more simple
      //select.GroupbyClauseText := 'f1,f2';

      select.SortClause := TLzOrderByList.Create(false);

      lcOrderby := TLzOrderBy.Create(select);
      lcorderby.SortItemType := sitExpression;
      lcorderby.SortExpr := TLzCustomExpression.Create(select);
      lcorderby.SortExpr.AsText := 'f1';
      lcorderby.SortType := srtAsc;
      select.SortClause.Add(lcorderby);

      lcOrderby := TLzOrderBy.Create(select);
      lcorderby.SortItemType := sitExpression;
      lcorderby.SortExpr := TLzCustomExpression.Create(select);
      lcorderby.SortExpr.AsText := 'f2';
      lcorderby.SortType := srtdesc;
      select.SortClause.Add(lcorderby);

      lcOrderby := TLzOrderBy.Create(select);
      lcorderby.SortItemType := sitExpression;
      lcorderby.SortExpr := TLzCustomExpression.Create(select);
      lcorderby.SortExpr.AsText := 'f3';
      select.SortClause.Add(lcorderby);

      lcsql := lcsql+return_code+select.AsText+';';
    finally
      select.SortClause.free;
      select.free;
    end;

    // select empname from emp union select deptname from dept ;

    // top level
    select := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    leftquery := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    rightquery := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
    try
      select.IsParsed := true; // must be set to true

      leftquery.IsParsed := true;
      fd := TLzField.Create(leftquery);
      fd.FieldName := 'empname';
      leftquery.Fields.Add(fd);
      ji := TLzJoin.Create(leftquery);
      ji.JoinTable := TLzTable.Create(leftquery);
      ji.JoinTable.TableName := 'emp';
      leftquery.JoinTables.Add(ji);

      rightquery.IsParsed := true;
      fd := TLzField.Create(rightquery);
      fd.FieldName := 'deptname';
      rightquery.Fields.Add(fd);
      ji := TLzJoin.Create(rightquery);
      ji.JoinTable := TLzTable.Create(rightquery);
      ji.JoinTable.TableName := 'dept';
      rightquery.JoinTables.Add(ji);

      select.LeftStmt := leftquery;
      select.RightStmt := rightquery;

      select.SelectSetType := sltUnion;
      lcsql := lcsql+return_code+select.AsText+';';

      select.SelectSetType := sltUnionAll;
      lcsql := lcsql+return_code+select.AsText+';';

      select.SelectSetType := sltMinus;
      lcsql := lcsql+return_code+select.AsText+';';

      select.SelectSetType := sltIntersect;
      lcsql := lcsql+return_code+select.AsText+';';

      select.SortClause := TLzOrderByList.Create(false);

      lcOrderby := TLzOrderBy.Create(select);
      lcOrderby.AsText := 'f1';
      select.SortClause.Add(lcorderby);
      lcsql := lcsql+return_code+select.AsText+';';

    finally
      select.SortClause.free;
      leftquery.Free;
      rightquery.free;
      select.free;
    end;

    pptext := ppsql(lcsql,pdbvendor); //dbvmysql

      result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

finally
  lcstrs.free;
end;

end;

function  builddelete(var retStr : lzstring; pdbvendor : TDBVendor ):boolean;
var
  lcstrs : Tlzstringlist;
  lcstmt : TDeleteSqlStatement;
  lcsql,pptext : Lzstring;
//  lccn : TLzConstraint;
  lcexpr  : TLzCustomExpression;
//  lcst : TSourceToken;
  ji : TLzJoin;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('delete from table1 where f1 = 1;');
    lcstrs.Add('delete table1 where f1 = 1;');

    lcstrs.Add('delete table1 where f1 = 1 returning expr1,expr2 into f1,f2;');
    lcstrs.Add('delete table1 where f1 = 1 returning expr1,expr2 bulk collect into f1,f2;');

    lcstrs.Add('delete table1 from table2 where f1 = 1 returning expr1,expr2 bulk collect into f1,f2;');



    lcstmt := TDeleteSqlStatement.Create(pdbvendor); //dbvmssql
    try
      lcstmt.Table := TLzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';
      lcstmt.WhereClauseText := 'f1=1';

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.IsHasFrom := false;

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.ReturningClause := TLzReturningClause.Create(lcstmt);
      lcstmt.ReturningClause.RowList := TLz_list.Create(lcstmt);
      lcstmt.ReturningClause.NameList := TLz_list.Create(lcstmt);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr1';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr2';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f1';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f2';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.ReturningClause.IntoType := 2; //bulk collect into
      lcsql := lcsql+return_code+lcstmt.AsText+';';

      //add from clause
      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 'table2';
      lcstmt.JoinTables.Add(ji);

      lcsql := lcsql+return_code+lcstmt.AsText+';';


    finally
      lcstmt.Free;
    end;

{
    lcstmt := TDeleteSqlStatement.Create(dbvmssql);
    try
      lcstmt.Table := TLzTable.Create(lcstmt);

      lcsql := lcsql+return_code+lcstmt.AsText;
    finally
      lcstmt.Free;
    end;
}
      pptext := ppsql(lcsql,pdbvendor);//dbvmssql
      result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

  finally
    lcstrs.free;
  end;

end;

function  buildupdate(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  lcstrs : Tlzstringlist;
  lcstmt : TUpdateSqlStatement;
  lcsql,pptext : Lzstring;
//  lccn : TLzConstraint;
  lcexpr  : TLzCustomExpression;
//  lcst : TSourceToken;
  ji,ji2 : TLzJoin;
  lcfield : TLzField;
//  lctable : TLzTable;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('update table1 set f1 = 1,f2 = 2;');
    lcstrs.Add('update table1,table2  set f1 = 1,f2 = 2 from table3,table4;');

    lcstrs.Add('update table1,table2  set f1 = 1,f2 = 2 from table3,table4 where f3 =1 returning expr1,expr2 into f1,f2;');

    lcstrs.Add('update (select f1,f2 from t1) as b set f1 = 1,f2 = 2;');

    lcstmt := TUpdateSqlStatement.Create(pdbvendor); // dbvmssql
    try
      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 'table1';


      lcstmt.UpdateTables.Add(ji);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldExpr := TLzCustomExpression.Create(lcstmt);
      lcfield.AsText := 'f1 = 1';
      lcstmt.Fields.Add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldExpr := TLzCustomExpression.Create(lcstmt);
      lcfield.AsText := 'f2 = 2';
      lcstmt.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 'table2';
      lcstmt.UpdateTables.Add(ji);


      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 'table3';
      lcstmt.JoinTables.Add(ji);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 'table4';
      lcstmt.JoinTables.Add(ji);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.WhereClauseText := 'f3=1';

      lcstmt.ReturningClause := TLzReturningClause.Create(lcstmt);
      lcstmt.ReturningClause.RowList := TLz_list.Create(lcstmt);
      lcstmt.ReturningClause.NameList := TLz_list.Create(lcstmt);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr1';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr2';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f1';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f2';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.Free;
    end;

     // update (select f1,f2 from t1) as b set f1 = 1,f2 = 2;

    lcstmt := TUpdateSqlStatement.Create(pdbvendor); //  dbvmssql
    try
      ji := TLzJoin.Create(lcstmt);

      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableType := lttSubquery;
      ji.JoinTable.SubQuery := TSelectSqlStatement.Create(pdbvendor); // dbvmssql
      TSelectSqlStatement(ji.JoinTable.SubQuery).IsParsed := true;
      TSelectSqlStatement(ji.JoinTable.SubQuery).WithParenthesis := 1;

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f1';
      ji.JoinTable.SubQuery.Fields.add(lcfield);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f2';
      ji.JoinTable.SubQuery.Fields.add(lcfield);


      ji2 := TLzJoin.Create(lcstmt);
      ji2.JoinTable := TLzTable.Create(lcstmt);
      ji2.JoinTable.TableName := 't1';
      TSelectSqlStatement(ji.JoinTable.SubQuery).JoinTables.Add(ji2);

      ji.newalias := TLz_aliasclause.Create(lcstmt);
      ji.newalias._withas := true;
      ji.newalias._aliastoken := TSourceToken.Create(lcstmt);
      ji.newalias._aliastoken.astext := 'b';

      lcstmt.UpdateTables.Add(ji);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldExpr := TLzCustomExpression.Create(lcstmt);
      lcfield.AsText := 'f1 = 1';
      lcstmt.Fields.Add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldExpr := TLzCustomExpression.Create(lcstmt);
      lcfield.AsText := 'f2 = 2';
      lcstmt.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      ji.JoinTable.SubQuery.free;
      lcstmt.Free;
    end;

    pptext := ppsql(lcsql,pdbvendor); // dbvmssql

      result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := pptext;


  finally
    lcstrs.free;
  end;

end;
function  buildinsertMySQL(var retStr : lzstring; pdbvendor : TDBVendor ):boolean;
var
  lcstrs : Tlzstringlist;
  lcstmt : TInsertSqlStatement;
  lcsql,pptext : Lzstring;
//  lcexpr  : TLzCustomExpression;
//  lcst : TSourceToken;
 // ji,ji2 : TLzJoin;
  lcfield : TLzField;
//  lctable : TLzTable;
  lcMultiValues : TLz_list;
  lcValues : TLzFieldList;
  lctoken1,lctoken2,lctoken3 : TSourceToken;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('insert into table1 values(v1,v2),(v3,v4);');
 //   lcstrs.Add('insert into table1 set a=b,date=now();');
 //   lcstrs.Add('insert into table1(col1,col2) select f1,f2 from t2;');


    lcstmt := TInsertSqlStatement.Create(pdbvendor); //   dbvmysql
    try
    //insert into table1 values(v1,v2),(v3,v4);

      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';
      lcMultiValues := TLz_list.Create(lcstmt);

      lcValues := TLzFieldList.Create(false);
      lctoken1 := TSourceToken.Create(lcstmt);
      lctoken1.AsText := ',';
      lctoken2 := TSourceToken.Create(lcstmt);
      lctoken2.AsText := '(';
      lctoken3 := TSourceToken.Create(lcstmt);
      lctoken3.AsText := ')';
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v1';
      lcValues.Add(lcfield);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v2';
      lcfield.TokenBefore := lctoken1;
      lcValues.Add(lcfield);
      lcValues.RawTokens.Add(lctoken2);
      lcValues.RawTokens.Add(lctoken3);
      lcMultiValues.Add(lcvalues);

      lcValues := TLzFieldList.Create(false);
      lctoken1 := TSourceToken.Create(lcstmt);
      lctoken1.AsText := ',';
      lctoken2 := TSourceToken.Create(lcstmt);
      lctoken2.AsText := '(';
      lctoken3 := TSourceToken.Create(lcstmt);
      lctoken3.AsText := ')';
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v3';
      lcValues.Add(lcfield);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v4';
      lcfield.TokenBefore := lctoken1;
      lcValues.Add(lcfield);
      lcValues.RawTokens.Add(lctoken2);
      lcValues.RawTokens.Add(lctoken3);
      lcValues.TokenBefore := lctoken1;
      lcMultiValues.Add(lcvalues);

      lcstmt.MultiValues := lcMultiValues;

      lcsql := lcsql+return_code+lcstmt.AsText+';';


    finally
      lcstmt.free;
    end;
 {
    lcstmt := TInsertSqlStatement.Create(dbvmysql);
    try
     // insert into table1 set a=b,date=now();

      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';
      lcMultiValues := TLz_list.Create(lcstmt);

      lcValues := TLzFieldList.Create(false);
      lctoken1 := TSourceToken.Create(lcstmt);
      lctoken1.AsText := ',';
      lctoken2 := TSourceToken.Create(lcstmt);
      lctoken2.AsText := '(';
      lctoken3 := TSourceToken.Create(lcstmt);
      lctoken3.AsText := ')';
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v1';
      lcValues.Add(lcfield);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v2';
      lcfield.TokenBefore := lctoken1;
      lcValues.Add(lcfield);
      lcValues.RawTokens.Add(lctoken2);
      lcValues.RawTokens.Add(lctoken3);
      lcMultiValues.Add(lcvalues);

      lcValues := TLzFieldList.Create(false);
      lctoken1 := TSourceToken.Create(lcstmt);
      lctoken1.AsText := ',';
      lctoken2 := TSourceToken.Create(lcstmt);
      lctoken2.AsText := '(';
      lctoken3 := TSourceToken.Create(lcstmt);
      lctoken3.AsText := ')';
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v3';
      lcValues.Add(lcfield);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v4';
      lcfield.TokenBefore := lctoken1;
      lcValues.Add(lcfield);
      lcValues.RawTokens.Add(lctoken2);
      lcValues.RawTokens.Add(lctoken3);
      lcValues.TokenBefore := lctoken1;
      lcMultiValues.Add(lcvalues);

      lcstmt.MultiValues := lcMultiValues;

      lcsql := lcsql+return_code+lcstmt.AsText+';';


    finally
      lcstmt.free;
    end;



    lcstmt := TInsertSqlStatement.Create(dbvmysql);
    try
      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableType := lttSubquery;
      lcstmt.Table.SubQuery := TSelectSqlStatement.Create(dbvmysql);
      lcstmt.Table.SubQuery.IsParsed := true;
      lcstmt.Table.SubQuery.WithParenthesis := 1;


      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.Table.SubQuery.Fields.add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.Table.SubQuery.Fields.add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';

      lcstmt.Table.SubQuery.JoinTables.Add(ji);


      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v1';
      lcstmt.Values.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v2';
      lcstmt.Values.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.Table.aliasclause := TLz_aliasclause.Create(lcstmt);
      lcstmt.Table.aliasclause._aliastoken := TSourceToken.Create(lcstmt);
      lcstmt.Table.aliasclause._aliastoken.AsText := 't2alias';

      lcsql := lcsql+return_code+lcstmt.AsText+';';
    finally
      lcstmt.Table.SubQuery.free;
      lcstmt.free;
    end;


    lcstmt := TInsertSqlStatement.Create(dbvmysql);
    try
      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col1';
      lcstmt.fields.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col2';
      lcstmt.fields.Add(lcfield);

      lcstmt.ValueType := ivtsubquery;
      lcstmt.SubQuery := TSelectSqlStatement.Create(dbvmysql);
      lcstmt.SubQuery.IsParsed := true;

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.SubQuery.Fields.add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.SubQuery.Fields.add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';

      lcstmt.SubQuery.JoinTables.Add(ji);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.ReturningClause := TLzReturningClause.Create(lcstmt);
      lcstmt.ReturningClause.RowList := TLz_list.Create(lcstmt);
      lcstmt.ReturningClause.NameList := TLz_list.Create(lcstmt);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr1';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr2';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcst := TSourceToken.Create(lcstmt);
      lcst.AsText := 'f1';
      lcstmt.ReturningClause.NameList.Add(lcst);

      lcst := TSourceToken.Create(lcstmt);
      lcst.AsText := 'f2';
      lcstmt.ReturningClause.NameList.Add(lcst);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.SubQuery.Free;
      lcstmt.free;
    end;
}
     pptext := ppsql(lcsql,pdbvendor); // dbvmysql
       result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

  finally
    lcstrs.free;
  end;

end;

function  buildinsert(var retStr : lzstring; pdbvendor : TDBVendor ):boolean;
var
  lcstrs : Tlzstringlist;
  lcstmt : TInsertSqlStatement;
  lcsql,pptext : Lzstring;
  lcexpr  : TLzCustomExpression;
//  lcst : TSourceToken;
  ji : TLzJoin;
  lcfield : TLzField;
//  lctable : TLzTable;
  lcfieldlist,lcfieldlist2,lcfieldlist3 : tlzFieldList;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('insert into table1 values(v1,v2);');
    lcstrs.Add('insert into table1(col1,col2) values(v1,v2);');
    // multi insert in sql server 2008
    lcstrs.Add('insert into table1(col1,col2) values(v1,v2),(v3,v4),(v5,v6);');
    lcstrs.Add('insert into (select f1,f2 from t2) values(v1,v2);');
    lcstrs.Add('insert into (select f1,f2 from t2) t2alias values(v1,v2);');

    lcstrs.Add('insert into table1(col1,col2) select f1,f2 from t2;');

    lcstrs.Add('insert into table1(col1,col2) select f1,f2 from t2 returning expr1,expr2 into f1,f2;');


    lcstmt := TInsertSqlStatement.Create(pdbvendor); //  dbvmssql
    try
      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';

      lcfieldlist := tlzfieldlist.Create(false);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v1';
      lcfieldlist.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v2';
      lcfieldlist.Add(lcfield);

      lcstmt.MultiValues.Add(lcfieldlist);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col1';
      lcstmt.fields.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col2';
      lcstmt.fields.Add(lcfield);


      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcfieldlist2 := tlzfieldlist.Create(false);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v3';
      lcfieldlist2.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v4';
      lcfieldlist2.Add(lcfield);

      lcstmt.MultiValues.Add(lcfieldlist2);

      lcfieldlist3 := tlzfieldlist.Create(false);
      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v5';
      lcfieldlist3.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v6';
      lcfieldlist3.Add(lcfield);

      lcstmt.MultiValues.Add(lcfieldlist3);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.free;
    end;


    lcstmt := TInsertSqlStatement.Create(pdbvendor); //  dbvmssql
    try
      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableType := lttSubquery;
      lcstmt.Table.SubQuery := TSelectSqlStatement.Create(pdbvendor);  // dbvmssql
      TSelectSqlStatement(lcstmt.Table.SubQuery).IsParsed := true;
      TSelectSqlStatement(lcstmt.Table.SubQuery).WithParenthesis := 1;


      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.Table.SubQuery.Fields.add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.Table.SubQuery.Fields.add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';

      TSelectSqlStatement(lcstmt.Table.SubQuery).JoinTables.Add(ji);


      lcfieldlist := tlzfieldlist.Create(false);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v1';
      lcfieldlist.Add(lcfield);
      //lcstmt.Values.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'v2';
      lcfieldlist.Add(lcfield);
      //lcstmt.Values.Add(lcfield);

      lcstmt.MultiValues.Add(lcfieldlist);

      lcsql := lcsql+return_code+lcstmt.AsText+';';


      lcstmt.Table.aliasclause := TLz_aliasclause.Create(lcstmt);
      lcstmt.Table.aliasclause._aliastoken := TSourceToken.Create(lcstmt);
      lcstmt.Table.aliasclause._aliastoken.AsText := 't2alias';

      lcsql := lcsql+return_code+lcstmt.AsText+';';
    finally
      lcstmt.Table.SubQuery.free;
      lcstmt.free;
    end;


    lcstmt := TInsertSqlStatement.Create(pdbvendor); //  dbvmssql
    try
      lcstmt.Table := TlzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'table1';

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col1';
      lcstmt.fields.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'col2';
      lcstmt.fields.Add(lcfield);

      lcstmt.ValueType := ivtsubquery;
      lcstmt.SubQuery := TSelectSqlStatement.Create(pdbvendor); //  dbvmssql
      lcstmt.SubQuery.IsParsed := true;

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.SubQuery.Fields.add(lcfield);

      lcfield := TLzField.create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.SubQuery.Fields.add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';

      lcstmt.SubQuery.JoinTables.Add(ji);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcstmt.ReturningClause := TLzReturningClause.Create(lcstmt);
      lcstmt.ReturningClause.RowList := TLz_list.Create(lcstmt);
      lcstmt.ReturningClause.NameList := TLz_list.Create(lcstmt);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr1';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'expr2';
      lcstmt.ReturningClause.RowList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f1';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcexpr  := TLzCustomExpression.create(lcstmt);
      lcexpr.AsText := 'f2';
      lcstmt.ReturningClause.NameList.Add(lcexpr);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.SubQuery.Free;
      lcstmt.free;
    end;

     pptext := ppsql(lcsql,pdbvendor);  //  dbvmssql
       result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+return_code+'***build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

  finally
    lcstrs.free;
  end;

end;

function  buildcreatetableMySQL(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  lcConstraintColumn: TLzConstraintColumn;
  lcstrs : Tlzstringlist;
  lcstmt : TCreateTablesqlStatement;
  lcsql,pptext : Lzstring;
//  lcexpr  : TLzCustomExpression;
  lcst1,lcst2,lcst3 : TSourceToken;
  ji : TLzJoin;
  lcfield : TLzField;
//  lctable : TLzTable;
  lccn : TLzConstraint;
  lcattr1,lcattr2 : TLz_attr;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('create table tn(f1 float,f2 decimal);');
    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null);');
    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null , primary key (f1,f2));');
    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null , primary key (f1,f2), foreign key keyname (f3) references scott.dept (f4) on update restrict match full);');
    lcstrs.Add('create table tn(f1 float,f2 decimal) as select f1,f2 from t2;');


    lcstmt := TCreateTablesqlStatement.Create(pdbvendor);  //   dbvmysql
    try
      lcstmt.Table := TLzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'tn';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f1';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'float';
      lcstmt.Table.Fields.Add(lcfield);

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f2';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'decimal';
      lcstmt.Table.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f3';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'char(2)';
      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clColumn;
		  lccn.ConstraintType := ctNotnull;
      lcfield.ColumnConstraints.Add(lccn);
      lcstmt.Table.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';


      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clTable;
      // primary key
		  lccn.ConstraintType := ctPrimarykey;

      lccn.ColumnNameList.AsText := 'f1,f2';

      lcstmt.Table.TableConstraints.Add(lccn);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      // foreign key with references
      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clTable;
		  lccn.ConstraintType := ctForeignkey;
      lccn._stMySQLIndexName := TSourceToken.Create(lccn);
      lccn._stMySQLIndexName.AsText := 'keyname';

      lccn.ColumnNameList.AsText := 'f3';

      lccn.RefClause := TLzConstraintRefClause.Create(lccn);
      lccn.RefClause.q_name := TLz_attr.Create(lccn);
      lccn.RefClause.q_name.relname := TSourceToken.Create(lccn);
      lccn.RefClause.q_name.relname.AsText := 'scott.dept';


      lcConstraintColumn := TLzConstraintColumn.Create(lccn);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccn);
      lcConstraintColumn.ColumnName.AsText := 'f4';
      lccn.RefClause.ConstraintColumnList.Add(lcConstraintColumn);


      lccn.RefClause.KeyMatch :=  ckmFull;
      lccn.RefClause._keymatchnode := TLz_DummyNode.Create(lccn);
      lccn.RefClause._keymatchnode.token1 := TSourceToken.Create(lccn);
      lccn.RefClause._keymatchnode.token1.AsText := 'match';
      lccn.RefClause._keymatchnode.token2 := TSourceToken.Create(lccn);
      lccn.RefClause._keymatchnode.token2.astext := 'full';


      lccn.RefClause.KeyAction := catUpdate;
      lcst1 := TSourceToken.create(lccn);
      lcst1.AsText := 'on';
      lcst2 := TSourceToken.create(lccn);
      lcst2.AsText := 'update';
      lcst3 := TSourceToken.create(lccn);
      lcst3.AsText := 'restrict';

      lccn.RefClause._keyactionnode := TLz_dummynode.Create(lccn);
      lccn.RefClause._keyactionnode.token1 := lcst1;
      lccn.RefClause._keyactionnode.token2 := lcst2;
      lccn.RefClause._keyactionnode.token3 := lcst3;

      lcstmt.Table.TableConstraints.Add(lccn);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.free;
    end;

    lcstmt := TCreateTablesqlStatement.Create(pdbvendor); //  dbvmysql
    try
      lcstmt.Table := TLzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'tn';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f1';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'float';
      lcstmt.Table.Fields.Add(lcfield);

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f2';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'decimal';
      lcstmt.Table.Fields.Add(lcfield);

      lcstmt.SelectStmt := TSelectSqlStatement.Create(dbvmysql);
      lcstmt.SelectStmt.IsParsed := true; // must be set to true

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.SelectStmt.Fields.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.SelectStmt.Fields.Add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';
      lcstmt.SelectStmt.JoinTables.Add(ji);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.SelectStmt.free;
      lcstmt.free;
    end;

    pptext := ppsql(lcsql,pdbvendor);  //  dbvmysql
    result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+'build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

  finally
    lcstrs.free;
  end;

end;

function  buildcreatetable(var retStr : lzstring; pdbvendor : TDBVendor):boolean;
var
  lcConstraintColumn: TLzConstraintColumn;
  lcstrs : Tlzstringlist;
  lcstmt : TCreateTablesqlStatement;
  lcsql,pptext : Lzstring;
//  lcexpr  : TLzCustomExpression;
  lcst1,lcst2,lcst3 : TSourceToken;
  ji : TLzJoin;
  lcfield : TLzField;
//  lctable : TLzTable;
  lccn : TLzConstraint;
  lcattr1,lcattr2 : TLz_attr;
begin
  lcstrs := Tlzstringlist.Create;
  try
    lcstrs.Add('create table tn(f1 float,f2 decimal);');
    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null);');

    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null check (f3>10));');

    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null check (f3>10), primary key (f1,f2));');

    lcstrs.Add('create table tn(f1 float,f2 decimal,f3 char(2) not null check (f3>10), primary key (f1,f2), foreign key (f3) references scott.dept (f4) on update restrict );');

    lcstrs.Add('create table tn(f1 ,f2 ) as  select f1,f2 from t2;');


    lcstmt := TCreateTablesqlStatement.Create(pdbvendor); // dbvmysql
    try
      lcstmt.Table := TLzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'tn';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f1';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'float';
      lcstmt.Table.Fields.Add(lcfield);

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f2';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'decimal';
      lcstmt.Table.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f3';
      lcfield.FieldDataType := TLz_typename.Create(lcstmt);
      lcfield.FieldDataType.AsText := 'char(2)';
      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clColumn;
		  lccn.ConstraintType := ctNotnull;
      lcfield.ColumnConstraints.Add(lccn);
      lcstmt.Table.Fields.Add(lcfield);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clColumn;
      lccn.ConstraintType := ctCheck;
      lccn.colexpr := TLzCustomExpression.Create(lccn);
      lccn.colexpr.astext := 'f3>10';
      lcfield.ColumnConstraints.Add(lccn);


      lcsql := lcsql+return_code+lcstmt.AsText+';';

      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clTable;
      // primary key
		  lccn.ConstraintType := ctPrimarykey;

      lccn.ColumnNameList.AsText := 'f1,f2';

      lcstmt.Table.TableConstraints.Add(lccn);
      lcstmt.Table.TableConstraints[0].TokenBefore := TSourceToken.Create(lcstmt);
      lcstmt.Table.TableConstraints[0].TokenBefore.astext := ',';


      lcsql := lcsql+return_code+lcstmt.AsText+';';

      // foreign key with references
      lccn := TLzConstraint.Create(lcstmt);
		  lccn.ConstraintLevel := clTable;
		  lccn.ConstraintType := ctForeignkey;


      lccn.ColumnNameList.AsText := 'f3';

      lccn.RefClause := TLzConstraintRefClause.Create(lccn);
      lccn.RefClause.q_name := TLz_attr.Create(lccn);
      lccn.RefClause.q_name.relname := TSourceToken.Create(lccn);
      lccn.RefClause.q_name.relname.AsText := 'scott.dept';

      lcConstraintColumn := TLzConstraintColumn.Create(lccn);
      lcConstraintColumn.ColumnName := TLz_attr.Create(lccn);
      lcConstraintColumn.ColumnName.AsText := 'f4';
      lccn.RefClause.ConstraintColumnList.Add(lcConstraintColumn);



      lccn.RefClause.KeyAction := catUpdate;
      lcst1 := TSourceToken.create(lccn);
      lcst1.AsText := 'on';
      lcst2 := TSourceToken.create(lccn);
      lcst2.AsText := 'update';
      lcst3 := TSourceToken.create(lccn);
      lcst3.AsText := 'restrict';

      lccn.RefClause._keyactionnode := TLz_dummynode.Create(lccn);
      lccn.RefClause._keyactionnode.token1 := lcst1;
      lccn.RefClause._keyactionnode.token2 := lcst2;
      lccn.RefClause._keyactionnode.token3 := lcst3;

      lcstmt.Table.TableConstraints.Add(lccn);

      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.free;
    end;

    lcstmt := TCreateTablesqlStatement.Create(pdbvendor); //  dbvmssql
    try
      lcstmt.Table := TLzTable.Create(lcstmt);
      lcstmt.Table.TableName := 'tn';

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f1';
      lcfield.FieldDataType := nil;
      lcstmt.Table.Fields.Add(lcfield);

      lcfield := TlzField.Create(lcstmt);
      lcfield.FieldType := lftColumn;
      lcfield.ColumnName := TSourceToken.Create(lcstmt);
      lcfield.ColumnName.AsText := 'f2';
      lcfield.FieldDataType := nil;
      lcstmt.Table.Fields.Add(lcfield);

      lcstmt.SelectStmt := TSelectSqlStatement.Create(dbvmysql);
      lcstmt.SelectStmt.IsParsed := true; // must be set to true

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f1';
      lcstmt.SelectStmt.Fields.Add(lcfield);

      lcfield := TLzField.Create(lcstmt);
      lcfield.FieldName := 'f2';
      lcstmt.SelectStmt.Fields.Add(lcfield);

      ji := TLzJoin.Create(lcstmt);
      ji.JoinTable := TLzTable.Create(lcstmt);
      ji.JoinTable.TableName := 't2';
      lcstmt.SelectStmt.JoinTables.Add(ji);


      lcsql := lcsql+return_code+lcstmt.AsText+';';

    finally
      lcstmt.SelectStmt.free;
      lcstmt.free;
    end;

    pptext := ppsql(lcsql,pdbvendor); //  dbvmssql
    result := comparewithouttoken(pptext,lcstrs.Text) ;

      if not result then
        pptext := pptext+return_code+'build sql error:'+return_code+lcstrs.text;

      retStr := pptext;

  finally
    lcstrs.free;
  end;

end;

function  buildselectwithwhere(var retStr : lzstring; pdbvendor : TDBVendor = dbvmssql):boolean;
var
  select : TSelectSqlStatement;
  fd : TLzField;
  ji : TLzJoin;
  lcsql : lzstring;
  lcexpr : TLzCustomExpression;
begin
    result := true;
   // select e.ename  from emp e where e.deptid = d.id;
    select := TSelectSqlStatement.Create(dbvmssql);//(pdbvendor); //dbvmssql
    try
      select.IsParsed := true; // must be set to true
      fd := TLzField.Create(select);
      fd.FieldName := 'ename';
      fd.FieldPrefix := 'e';
      select.Fields.Add(fd);

      ji := TLzJoin.Create(select);
      ji.JoinTable := TLzTable.Create(select);
      ji.JoinTable.TableName := 'emp';
      ji.JoinTable.aliasclause := Tlz_aliasclause.Create(select);
      ji.JoinTable.aliasclause._aliastoken := TSourceToken.create(select);
      ji.JoinTable.aliasclause._aliastoken.AsText := 'e';
      select.JoinTables.Add(ji);
      lcexpr := TLzCustomExpression.Create(nil);
      try
        lcexpr.AsText := 'e.deptid = d.id';
        select.WhereClause := lcexpr;

        lcsql := lcsql+return_code+select.AsText+';';

        retStr := lcsql;
      finally
        lcexpr.Free;
      end;
    finally
      select.free;
    end;

end;

end.
